/*-----------------------------------------------------------------------
  AUTOSTRT - copy files from one directory to another and reboot PLC
-----------------------------------------------------------------------*/

Parse Source . . filename
drive = LEFT(filename,2)

/* clear screen         */
do 13
	SAY ''
end

SAY ' *****************************************************************'
SAY ' *****                                                     *******'
SAY ' **                                                             **'
SAY ' **         Software Update + WebServer installation            **'
SAY ' **         + HTTPcli.dlm und DHCPcli.dlm und VNCsvr.dlm        **'
SAY ' **         + Betriebssystem update                             **'
SAY ' **                                                             **'
SAY ' *****                                                     *******'
SAY ' *****************************************************************'
SAY ''

rc = MILLISLEEP(5000)


If (stream(drive'\PROG','C','QUERY EXISTS') <> '') Then Do
  Call update_sps
  SAY ''
End
If (stream(drive'\VISU','C','QUERY EXISTS') <> '') Then Do
  Call update_visu
  SAY ''
End
If (stream(drive'\Boot','C','QUERY EXISTS') <> '') Then Do
  Call update_boot
  SAY ''
End
If (stream(drive'\Webserver','C','QUERY EXISTS') <> '') Then Do
  Call update_Web
  SAY ''
End
If (stream(drive'\Network','C','QUERY EXISTS') <> '') Then Do
  Call update_Net
  SAY ''
End
If (stream(drive'\OS','C','QUERY EXISTS') <> '') Then Do
  Call update_OS
  SAY ''
End

If (stream('C:\SYSMSG','C','QUERY EXISTS') <> '') Then Do
  Call get_eventlog
  SAY ''
End

/* Touch mu nach dem Booten immer neu eingestellt werden */
REM del touchdat.cfg

/* set CPU in reset to show that update is finished */
'reset'

call reboot_plc drive

Exit


/*##########################################################################################################*/
/*------------Update OS--------------------*/

update_OS: Procedure
Say ' '
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **        Update the OS                                              **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

    Parse Source . . filename
    drive = LEFT(filename,2)
    source_dir = drive'\OS'
    dest_dir   = 'C:\LSLSYS'
	
		
	/*  Copy the OS File    */

    cmd = 'XCOPY 'source_dir'\EtvEdge.lbi ' dest_dir
    Address System cmd
    If rc \= 0 Then Do
      Say cmd' failed, rc='rc
      Call fatal_error
    End

		
	Call DirList(source_dir'\*.*', listOSFiles)

	i = listOSFiles.0
	
    Say 'Update OS ...('dest_dir'\EtvEdge.lbi)'
    cmd = 'Boot 'dest_dir'\EtvEdge.lbi'
	  
	rc = MILLISLEEP(1000)
    Address System cmd
	
/*    End   */
  return

Exit
/*------------Update Webserver--------------------*/

update_Net: Procedure
Say ' '
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **        Install the network files (HTTPcli.dlm and DHCPcli.dlm)    **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

    Parse Source . . filename
    drive = LEFT(filename,2)
    source_dir = drive'\Network'
    dest_dir   = 'C:\lslsys'


    if (stream('C:\LSLSYS','C','QUERY EXISTS') = '') then
      'MKDIR LSLSYS'

	  
	 /*  1.) Copy the DHCP DLM   */ 
	  
    cmd = 'COPY 'drive'\Network\DHCPCli.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd 

	
	/*  2.) Copy the HTTP DLM   */ 	
	
    cmd = 'COPY 'drive'\Network\HTTPCli.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd  

    /*Call DirList(dest_dir'*', listOSFiles)
    i = 1
    Do While ( (i <= listOSFiles.0) & listOSFiles.i.A_SUBDIR ) 
      i = i+1
    End
    If (listOSFiles.0 >= i ) Then Do
      Say 'Update OS ...('dest_dir''listOSFiles.i.Name')'
      cmd = 'Boot 'dest_dir''listOSFiles.i.Name
      Address System cmd
    End*/

    if rc >= 0 then 
      SAY 'Copy process was successfully...'  
    else
      SAY 'Copy process was not successfully...'

    /* ------------------- Zahl 99 in der 7-Segment Anzeige ausgeben ---------------- */
    /*cmd = 'setusercpustatus 5'
    Address System cmd

    Call Stream('autoexec.lsl','C','APPEND')
	retcode = Lineout('autoexec.lsl', '')
	retcode = Lineout('autoexec.lsl', 'SET OSHEAP 15000')
    Call Stream(filename,'C','CLOSE')
    If retcode \= 0 Then
      Return -1*/
    
    Say ''
    Say ' ***************************************************************'
    Say ' **                                                           **'
    Say ' **              Network Update finished !!!                  **'
    Say ' **                                                           **'
    Say ' ***************************************************************'
    Say '' 
  
  Return 0

Exit


/*########################################################################################################*/



/*------------Update Webserver--------------------*/

update_Web: Procedure
Say ' '
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **        REXX Macro to install the WEB Server on target system      **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

    Parse Source . . filename
    drive = LEFT(filename,2)
    source_dir = drive'\WebServer\Webroot'
    dest_dir   = 'C:\Webroot'

    if (stream('C:\WebServer\Webroot','C','QUERY EXISTS') = '') then
      'MKDIR Webroot'

    result = ZCOPY_intern(source_dir, dest_dir)    
    if result >= 0 then 
      SAY 'Copy process was successfully...'  
    else
      SAY 'Copy process was not successfully...'


    if (stream('C:\LSLSYS','C','QUERY EXISTS') = '') then
      'MKDIR LSLSYS'

	/*  0.) Copy the bootpic.bmo  */ 	
	
    cmd = 'COPY 'drive'\bootpic.bmo C:\'
    Say cmd
    Address System cmd  	  
	 

	/*  1.) Copy the Webserver DLM   */ 
	  
    cmd = 'COPY 'drive'\WebServer\WebSvr.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd 

	
	/*  2.) Copy the Webserver Functions DLM   */ 	
	
    cmd = 'COPY 'drive'\WebServer\WebFnc.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd  

	/*  3.) Copy the VNCServer Functions DLM   */ 	
	
    cmd = 'COPY 'drive'\WebServer\VNCsvr.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd 

	/*  4.) Copy the VNCServer Passwort DLM   */ 	
	
    cmd = 'COPY 'drive'\WebServer\vncpwd.txt C:\'
    Say cmd
    Address System cmd  

	
	/*  5.) Copy the ZLIB DLM   */ 	
	
	cmd = 'COPY 'drive'\WebServer\zlib.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd

	
	/*  6.) Copy the LRS-Server DLM   */ 	
	
	cmd = 'COPY 'drive'\WebServer\LRSsvr.dlm C:\LSLSYS\'
    Say cmd
    Address System cmd  	


	/*  7.) Copy the LRS Password File   */ 
	
	cmd = 'COPY 'drive'\WebServer\lrspwd.dat C:\'
    Say cmd
    Address System cmd  

    
    if (stream('C:\LRSPWDDEFAULT','C','QUERY EXISTS') = '') then
      'MKDIR LRSPWDDEFAULT'

    /* Copy the LRS Password File into the default folder   */ 
	
	cmd = 'COPY 'drive'\WebServer\lrspwd.dat C:\LRSPWDDEFAULT\'
    Say cmd
    Address System cmd 

    /* Copy the VNC Password File into the default folder   */ 
	
	cmd = 'COPY 'drive'\WebServer\vncpwd.txt C:\LRSPWDDEFAULT\'
    Say cmd
    Address System cmd 
 
	
    if rc >= 0 then 
      SAY 'Copy process was successfully...'  
    else
      SAY 'Copy process was not successfully...'

    /* ------------------- Zahl 99 in der 7-Segment Anzeige ausgeben ---------------- */
    cmd = 'setusercpustatus 5'
    Address System cmd

    Call Stream('autoexec.lsl','C','APPEND')
    retcode = Lineout('autoexec.lsl', '')
    retcode = Lineout('autoexec.lsl', 'REM START THE LRS SERVER IF IT IS NOT RUNNING')
    retcode = Lineout('autoexec.lsl', 'LRSSVR  START')
    retcode = Lineout('autoexec.lsl', 'REM START THE VNC SERVER')
    retcode = Lineout('autoexec.lsl', 'VNCSVR START')
    retcode = Lineout('autoexec.lsl', 'SETENV  WEBROOT  C:\WEBROOT\')
    
    retcode = Lineout('autoexec.lsl', 'WEBSVR START')
    Call Stream(filename,'C','CLOSE')
    
    If retcode \= 0 Then Do 
      Return -1
      Say ' Geht nit '
      rc = MILLISLEEP(5000)
    End
    
    Say ''
    Say ' ***************************************************************'
    Say ' **                                                           **'
    Say ' **              WebServer Update finished !!!                **'
    Say ' **                                                           **'
    Say ' ***************************************************************'
    Say '' 
  
  Return 0

Exit


/* ------------------- the functions below are important for  ----------------- */
/* ------------------- file operation (make dir, copy files, ..  ----------------- */
zcopy_intern: Procedure
  Parse Arg dir1, dir2

  retcode = Dirlist(dir1'\*.*',list)
  If retcode \= 0 Then Do
    Say 'Dirlist('dir1'\*.*) -> failed !'
    Return -1
  End    

  result = 0

  retcode = make_dir(dir2)
  If retcode \= 0 Then Do
    Return -1
  End

  i = 1
  Do While i <= list.0
    If list.i.A_SUBDIR = 0 Then Do
      cmd = 'COPY 'dir1'\'list.i.NAME' 'dir2'\'list.i.NAME
      Say cmd
      Address System cmd
      If rc \= 0 Then Do
        Say cmd' -> failed !'
        result = -1
      End
    End      
    Else Do
      If list.i.NAME \= '.' & list.i.NAME \= '..' Then Do
        retcode = zcopy_intern(dir1'\'list.i.NAME, dir2'\'list.i.NAME)
        If retcode \= 0 Then
          result = -1
      End
    End
    i = i + 1      
  end
  
  Return result

/*------------------------------------------------------------------------------
  make_dir(<directory>)
  
  Create a whole directory structure
  
  Result:
    Returns 0 when the whole directory structure could be created, 
    otherwise -1 is returned.
------------------------------------------------------------------------------*/
make_dir: Procedure
  Parse Arg dir
  
  n = 0
  flag_end = 0
  
  Do Forever

    /* strip trailing backslashes */
    revdir = reverse(dir)
    Do Forever
      If substr(revdir,1,1) = '\' Then Do
        If (substr(revdir,2,1) \= '') & (substr(revdir,2,1) \= ':') Then
          revdir = substr(revdir,2)
        Else Do
          flag_end = 1
          Leave
        End
      End
      Else
        Leave
    End      
    dir = reverse(revdir)
  
    If (stream(dir,'C','QUERY EXISTS') \= '') | (dir = '') | (flag_end = 1) Then Do
      /* create all other directories on the stack */
      Do While n > 0
        Pull dir
        cmd = 'MD 'dir
        Say cmd
        Address System cmd
        If rc \= 0 Then Do
          Say cmd' -> failed !'
          Return -1
        End
        n = n - 1
      End
      Leave
    End    
  
    push dir
    n = n + 1
    
    If n > 50 Then
      /* for safety */
      Return -1
    
    /* strip all characters until ':','\' is found or string is emptry */
    revdir = reverse(dir)
    Do Forever
      c = substr(revdir,1,1)
      If (c = '\') | (c = ':') | (c = '') Then
        Leave
      revdir = substr(revdir,2)
    End      
    dir = reverse(revdir)
    
  End

  Return 0

/*------------------------------------------------------------------------------
  logmsg
------------------------------------------------------------------------------*/
logmsg: Procedure Expose logfile
  Parse Arg txt
  
  line = Date('O')','Time('N')'  'txt
  If logfile \= '' Then
    Call append_line(logfile,line)
  
  Say line


/*------------Update SPS--------------------------*/
update_sps: Procedure
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **            Update Lasal Class 2 Programm (Software)               **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

  Parse Source . . filename
  drive = LEFT(filename,2)
  source_dir = drive'\PROG'
  dest_dir   = 'C:\LSLWORK'

  If (stream(dest_dir,'C','QUERY EXISTS') = '') Then Do
    cmd = 'MKDIR 'dest_dir
    Address System cmd
    If rc \= 0 Then Do
      Say cmd' failed, rc='rc
      Call fatal_error
    End
  End
  Else Do
    Call DirList(dest_dir'\*', listOSFiles)
    If (listOSFiles.0 >= 3 ) Then Do
       Say ' '
       Say 'Delete old LSLWORK Files'
       cmd = 'DEL 'dest_dir'\*'
       Address System cmd
    End
  End
  Say ' '
  Say 'Update LSLWORK ...'
  cmd = 'XCOPY 'source_dir'\* 'dest_dir
  Address System cmd
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End

  return

/*------------Update VISU--------------------------*/
update_visu: Procedure
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **         Update Lasal Screen Programm (Visualisierung)             **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

  Parse Source . . filename
  drive = LEFT(filename,2)
  source_dir = drive'\VISU'
  dest_dir   = 'C:\MPC'

  If (stream(dest_dir,'C','QUERY EXISTS') = '') Then Do
    cmd = 'MKDIR 'dest_dir
    Address System cmd
    If rc \= 0 Then Do
      Say cmd' failed, rc='rc
      Call fatal_error
    End
  End  
  Else DO
    Call DirList(dest_dir'\*', listOSFiles)
    If (listOSFiles.0 >= 3 ) Then Do
       Say ' '
       Say 'Delete old MPC Files'
       cmd = 'DEL 'dest_dir'\*'
       Address System cmd
    End
  End
  
  Say ' '
  Say 'Update Visu ...'
  cmd = 'XCOPY 'source_dir'\* 'dest_dir
  Address System cmd
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    /*Call fatal_error*/
  End

  

  return

/*------------Update Autoexec.lsl--------------------------*/
update_boot: Procedure
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **                Copy the Autoexec.lsl to the target                **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'
Say ' '
  Parse Source . . filename
  drive = LEFT(filename,2)
  source_dir = drive'\BOOT'
  dest_dir   = 'C:\\'

  Say ' '
  Say 'Update Autoexec.lsl ...'
  Say ' '
  cmd = 'QUCMD XCOPY 'source_dir'\autoexec.lsl 'dest_dir
  Address System cmd
  /*
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End
  */
  
  cmd = 'COPY 'drive'\visu\ipc.ini C:\'
  Address System cmd
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End    
  
  cmd = 'COPY 'drive'\BOOT\config.lsl C:\LSLSYS\'
  Address System cmd
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End  
  

  return

/*------------Update UserConfiguration--------------------------*/

update_userconf: Procedure

  Parse Source . . filename
  drive = LEFT(filename,2)
  source_dir = drive'\USER'
  dest_dir   = 'C:\\'

  Say 'Update Users Configuration ...'
  cmd = 'QUCMD XCOPY 'source_dir'\* 'dest_dir
  Address System cmd
  /*
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End
  */
  return

  
/*--------------Get Event logs --------------------*/
get_eventlog: Procedure
Say ' ***********************************************************************'
Say ' ***                                                                 ***'
Say ' **            Get the Event log Files from the target                **'
Say ' ***                                                                 ***'
Say ' ***********************************************************************'

  Parse Source . . filename
  drive = LEFT(filename,2)
  source_dir = 'c:\SYSMSG'
  dest_dir   = drive'\'

  Say 'Get EventLogs ...'
  cmd = 'QUCMD XCOPY 'source_dir'\* 'dest_dir
  Address System cmd
  /*
  If rc \= 0 Then Do
    Say cmd' failed, rc='rc
    Call fatal_error
  End
  */
  return  

	
 
/*------------Fehlermeldung ausgeben---------------*/
fatal_error: Procedure

  Parse Source . . filename
  Say
  Say
  Say 'Fatal error while executing 'filename
  Say ' ************************************************'
  Say ' ***                                          ***'
  Say ' ***              System halted               ***'
  Say ' ***                                          ***'
  Say ' ************************************************'
  Say
  Say
  Return

	Exit

 /*--------REBOOT SYSTEM AFTER USB REMOVED--------*/
	
reboot_plc: Procedure
	parse arg drive

	Say ' '
	Say '******************************************************'
	Say ' Please remove USB media (Terminal will restart after)'
	Say '******************************************************'
  	Say ' '

	'echo off'

	StickAvailable = 1
	DO WHILE (StickAvailable == 1)
		
		rc = MILLISLEEP(1000)

		drive
		
	  If rc \= 0 Then
	  	StickAvailable = 0
	end

	'echo on'

	Say ' USB Media has been removed'
	
	rc = MILLISLEEP(1000)
	Say ' '
	Say ' System is now rebooting...'

	rc = MILLISLEEP(1000)
	
	'echo off'

   'Reboot'

	Return
